MONGOEXPORT(1)

NAME
mongoexport - MongoDB Export Utility

  On this page

•   Synopsis

•   Availability

•   Syntax

•   Required Access

•   Behavior

•   Options

•   Examples

macOS Sierra and Go 1.6 Incompatibility

    Users running on macOS Sierra require the 3.2.10 or newer version of mongoexport.

SYNOPSIS

mongoexport is a command-line tool that produces a JSON or CSV export of data stored in a MongoDB instance.

Run mongoexport from the system command line, not the mongo shell.

SEE ALSO: mongoimport which provides the corresponding "import" capability.

AVAILABILITY

The mongoexport tool is part of the MongoDB tools package. Consult the installation guide for your platform for instructions on how to install the tools package as part of your MongoDB installation.

The tools package is also available from the MongoDB Download Center, either as a separate tools download, or contained within the TGZ or ZIP downloads, depending on platform. On Windows, the MSI installer includes all tools as part of the default installation.

TIP

If downloading the TGZ or ZIP files from the Download Center, you may want to update your PATH environment variable to include the directory where you installed these tools. See the installation guide for your platform for more information.

SYNTAX

mongoexport must be run directly from the system command line.

mongoexport --collection=<coll> [options]

You must specify the collection to export. If you do not specify an output file, mongoexport writes to the standard output (e.g. stdout).

  Connect to a MongoDB Instance

To connect to a local MongoDB instance running on port 27017, you do not have to specify the host or port.

For example, to export the specified collection to the specified output file from a local MongoDB instance running on port 27017:

mongoexport --collection=events --db=reporting --out=events.json

To specify a host and/or port of the MongoDB instance, you can either:

•   Specify the hostname and port in the --uri connection string:

    mongoexport --uri="mongodb://mongodb0.example.com:27017/reporting"  --collection=events  --out=events.json [additional options]

    If using the --uri connection string, specify the database as part of the string. You cannot use the command-line option --db in conjunction with the --uri connection string.

•   Specify the hostname and port in the --host:

    mongoexport --host="mongodb0.example.com:27017" --collection=events --db=reporting --out=events.json [additional options]

•   Specify the hostname and port in the --host and --port:

    mongoexport --host="mongodb0.example.com" --port=27017 --collection=events --db=reporting --out=events.json [additional options]

    For more information on the options available, see Options.

  Connect to a Replica Set

To connect to a replica set to export its data, you can either:

•   Specify the replica set name and members in the --uri connection string:

    mongoexport --uri="mongodb://mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com:27017/reporting?replicaSet=myReplicaSetName" --collection=events --out=events.json [additional options]

    If using the --uri connection string, specify the database as part of the string. You cannot use the command-line option --db in conjunction with the --uri connection string.

•   Specify the replica set name and members in the --host:

    mongoexport --host="myReplicaSetName/mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com" --collection=events --db=reporting --out=events.json [additional options]

    By default, mongoexport reads from the primary of the replica set. To override the default, you can specify the read preference:

•   You can specify the read preference in the --uri connection string

    mongoexport --uri="mongodb://mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com:27017/reporting?replicaSet=myReplicaSetName&readPreference=secondary" --collection=events --out=events.json [additional options]

    If specifying the read preference tags, include the readPreferenceTags option:

    mongoexport --uri="mongodb://mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com:27017/reporting?replicaSet=myReplicaSetName&readPreference=secondary&readPreferenceTags=region:east" --collection=events --out=events.json [additional options]

    If using the --uri connection string, specify the database as part of the string. You cannot use the command-line option --db in conjunction with the --uri connection string.

•   You can specify the read preference in using the --readPreference command-line option. The command-line option takes a string if specifying only the read preference mode:

    mongoexport --host="myReplicaSetName/mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com:27017" --readPreference=secondary --collection=events --db=reporting --out=events.json [additional options]

    Or, the command-line option can takes a quote-enclosed document '{ mode: <mode>, tagSets: [ <tag1>, ... ], maxStalenessSeconds:<num>}' to specify the mode, the optional read preference tag sets, and the optional maxStalenessSeconds:

    mongoexport --host="myReplicaSetName/mongodb0.example.com:27017,mongodb1.example.com:27017,mongodb2.example.com:27017" --readPreference='{mode: "secondary", tagSets: [ { "region": "east" } ]}' --collection=events --db=reporting --out=events.json [additional options]

    For more information on the options available, see Options.

  Connect to a Sharded Cluster

To connect to a sharded cluster to export its data, you can either:

•   Specify the hostname of the mongos instance in the --uri connection string

    mongoexport --uri="mongodb://mongos0.example.com:27017/reporting" --collection=events --out=events.json [additional options]

    If using the --uri connection string, specify the database as part of the string. You cannot use the command-line option --db in conjunction with the --uri connection string.

•   Specify the hostname and port of the mongos instance in the --host

    mongoexport --host="mongos0.example.com:27017" --collection=events --db=reporting --out=events.json[additional options]

    By default, mongoexport reads from the primary of the shard replica set. To override the default, you can specify the read preference:

•   You can specify the read preference in the --uri connection string

    mongoexport --uri="mongodb://mongos0.example.com:27017/reporting?readPreference=secondary" --collection=events --out=events.json [additional options]

    If specifying the read preference tags, include the readPreferenceTags option:

    mongoexport --uri="mongodb://mongos0.example.com:27017/reporting?readPreference=secondary&readPreferenceTags=region:east" --collection=events --out=events.json [additional options]

    If using the --uri connection string, specify the database as part of the string. You cannot use the command-line option --db in conjunction with the --uri connection string.

•   You can specify the read preference in using the --readPreference command-line option. The command-line option takes a string if specifying only the read preference mode:

    mongoexport --host="mongos0.example.com:27017" --readPreference=secondary --collection=events --db=reporting --out=events.json [additional options]

    Or, the command-line option can takes a quote-enclosed document '{ mode: <mode>, tagSets: [ <tag1>, ... ], maxStalenessSeconds:<num>}' to specify the mode, the optional read preference tag sets, and the optional maxStalenessSeconds:

    mongoexport --host="mongos0.example.com:27017" --readPreference='{mode: "secondary", tagSets: [ { "region": "east" } ]}' --collection=events --db=reporting --out=events.json [additional options]

    For more information on the options available, see Options.

    SEE ALSO: Examples

REQUIRED ACCESS

mongoexport requires read access on the target database.

Ensure that the connecting user possesses, at a minimum, the read role on the target database.

When connecting to a mongod or mongos that enforces /core/authentication, ensure you use the required security parameters based on the configured authentication mechanism.

BEHAVIOR

  Type Fidelity

WARNING: Avoid using mongoimport and mongoexport for full instance production backups. They do not reliably preserve all rich BSON data types, because JSON can only represent a subset of the types supported by BSON. Use mongodump and mongorestore as described in /core/backups for this kind of functionality.

Starting in version 4.2, mongoexport:

•   Outputs data in Extended JSON v2.0 (Relaxed mode) by default.

•   Outputs Extended JSON v2.0 (Canonical mode) if used with --jsonFormat.

    Earlier versions used Extended JSON v1.0 (Canonical mode).

    For example, the following insert operation in the mongo shell uses the various shell helpers for the BSON types Date and 64-bit integer:

    use test
    db.traffic.insert( { _id: 1, volume: NumberLong('2980000'), date: new Date() } )

    The argument to 64-bit integer must be quoted to avoid potential loss of accuracy.

    Use mongoexport to export the data:

    mongoexport --db=test --collection=traffic --out=traffic.json

    In version 4.2+, the exported data is in Extended JSON v2.0 (Relaxed mode).

    {"_id":1.0,"volume":2980000,"date":{"$date":"2019-08-05T16:18:29.559Z"}}

    To output in Extended JSON v2.0 (Canonical mode), include the --jsonFormat=canonical:

    mongoexport --db=test --collection=traffic --jsonFormat=canonical --out=traffic.json

    The exported data is in Extended JSON v2.0 (Canonical mode):

    {"_id":{"$numberDouble":"1.0"},"volume":{"$numberLong":"2980000"},"date":{"$date":{"$numberLong":"1565363188675"}}}

    In version 4.0 and earlier, the exported data is in Extended JSON v1.0 (Strict mode)

    {"_id":1.0,"volume":{"$numberLong":"2980000"},"date":{"$date":"2019-08-05T16:18:29.559Z"}}

  FIPS

Starting in version 4.2, MongoDB removes the --sslFIPSMode option for mongoexport. mongoexport will use FIPS compliant connections to mongod/mongos if the mongod/mongos instances are configured to use FIPS mode.

  Read Preference

By default, mongoexport uses read preference primary. To override the default, you can specify the read preference in the --readPreference command line option or in the --uri connection string.

Starting in version 4.2, if you specify read preference in the URI string and the --readPreference, the --readPreference value overrides the read preference specified in the URI string.

In earlier versions, the two options are incompatible.

OPTIONS

Changed in version 3.0.0: mongoexport removed the --dbpath as well as related --directoryperdb and --journal options. To use mongoexport, you must run mongoexport against a running mongod or mongos instance as appropriate.

Changed in version 3.0.0: mongoexport removed the --csv option. Use the --type=csv option to specify CSV format for the output.

mongoexport

--help
    Returns information on the options and use of mongoexport.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--quiet
    Runs mongoexport in a quiet mode that attempts to limit the amount of output.

    This option suppresses:

•   output from database commands

•   replication activity

•   connection accepted events

•   connection closed events

--version
    Returns the mongoexport release number.

--uri=<connectionString>
    New in version 3.4.6.

    Specify a resolvable URI connection string (enclose in quotes) to connect to the MongoDB deployment.

    --uri="mongodb://[username:password@]host1[:port1][,host2[:port2],...[,hostN[:portN]]][/[database][?options]]"

    For information on the components of the connection string, see the Connection String URI Format documentation.

    NOTE: For TLS/SSL options, use the command-line options instead of the URI options for TLS/SSL (Available starting in 4.2).

    IMPORTANT: The following command-line options cannot be used in conjunction with --uri option:

•   --host

•   --port

•   --db

•   --username

•   --password (if the URI connection string also includes the password)

•   --authenticationDatabase

•   --authenticationMechanism

    Instead, specify these options as part of your --uri connection string.

--host=<hostname><:port>, -h=<hostname><:port>
    Default: localhost:27017

    Specifies a resolvable hostname for the mongod to which to connect. By default, the mongoexport attempts to connect to a MongoDB instance running on the localhost on port number 27017.

    To connect to a replica set, specify the replSetName and a seed list of set members, as in the following:

    --host=<replSetName>/<hostname1><:port>,<hostname2><:port>,<...>

    When specifying the replica set list format, mongoexport always connects to the primary.

    You can also connect to any single member of the replica set by specifying the host and port of only that member:

    --host=<hostname1><:port>

    Changed in version 3.0.0: If you use IPv6 and use the <address>:<port> format, you must enclose the portion of an address and port combination in brackets (e.g. [<address>]).

    NOTE: You cannot specify both --host and --uri.

--port=<port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

    NOTE: You cannot specify both --port and --uri.

--ipv6
    Removed in version 3.0.

    Enables IPv6 support and allows mongoexport to connect to the MongoDB instance using an IPv6 network. Prior to MongoDB 3.0, you had to specify --ipv6 to use IPv6. In MongoDB 3.0 and later, IPv6 is always enabled.

--ssl
    New in version 2.6.

    Enables connection to a mongod or mongos that has TLS/SSL support enabled.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCAFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    Starting in version 3.4, if --tlsCAFile/net.tls.CAFile (or their aliases --sslCAFile/net.ssl.CAFile) is not specified and you are not using x.509 authentication, the system-wide CA certificate store will be used when connecting to an TLS/SSL-enabled server.

    To use x.509 authentication, --tlsCAFile or net.tls.CAFile must be specified unless using --tlsCertificateSelector or --net.tls.certificateSelector. Or if using the ssl aliases, --sslCAFile or net.ssl.CAFile must be specified unless using --sslCertificateSelector or net.ssl.certificateSelector.

    WARNING: Version 3.2 and earlier: For TLS/SSL connections (--ssl) to mongod and mongos, if the mongoexport runs without the --sslCAFile, mongoexport will not attempt to validate the server certificates. This creates a vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. Ensure that you always specify the CA file to validate the server certificates in cases where intrusion is a possibility.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains both the TLS/SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has CAFile enabled without allowConnectionsWithoutCertificates.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyPassword=<value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongoexport will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongoexport will prompt for a passphrase. See ssl-certificate-password.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCRLFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    Starting in MongoDB 4.0, if you specify --sslAllowInvalidCertificates or net.ssl.allowInvalidCertificates: true (or in MongoDB 4.2, the alias --tlsAllowInvalidateCertificates or net.tls.allowInvalidCertificates: true) when using x.509 authentication, an invalid certificate is only sufficient to establish a TLS/SSL connection but is insufficient for authentication.

    WARNING: Although available, avoid using the --sslAllowInvalidCertificates option if possible. If the use of --sslAllowInvalidCertificates is necessary, only use the option on systems where intrusion is not possible.

    If the mongo shell (and other mongodb-tools-support-ssl) runs with the --sslAllowInvalidCertificates option, the mongo shell (and other mongodb-tools-support-ssl) will not attempt to validate the server certificates. This creates a vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. If you only need to disable the validation of the hostname in the TLS/SSL certificates, see --sslAllowInvalidHostnames.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in TLS/SSL certificates. Allows mongoexport to connect to MongoDB instances even if the hostname in their certificates do not match the specified hostname.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--username=<username>, -u=<username>
    Specifies a username with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --password and --authenticationDatabase options.

    NOTE: You cannot specify both --username and --uri.

--password=<password>, -p=<password>
    Specifies a password with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --username and --authenticationDatabase options.

    Changed in version 3.0.2: To prompt the user for the password, pass the --username option without --password or specify an empty string as the --password value, as in --password "" .

    NOTE: You cannot specify both --password and --uri.

--authenticationDatabase=<dbname>
    Specifies the authentication database where the specified --username has been created. See user-authentication-database.

    NOTE: You cannot specify both --authenticationDatabase and --uri.

    If you do not specify an authentication database, mongoexport assumes that the database specified to export holds the user's credentials.

--authenticationMechanism=<name>
    Default: SCRAM-SHA-1

    Specifies the authentication mechanism the mongoexport instance uses to authenticate to the mongod or mongos.

    Changed in version 4.0: MongoDB removes support for the deprecated MongoDB Challenge-Response (MONGODB-CR) authentication mechanism.

    MongoDB adds support for SCRAM mechanism using the SHA-256 hash function (SCRAM-SHA-256).
    Value | Description
    SCRAM-SHA-1 | RFC 5802 standard Salted Challenge Response Authentication Mechanism using the SHA-1 hash function.
    SCRAM-SHA-256 | RFC 7677 standard Salted Challenge Response Authentication Mechanism using the SHA-256 hash function. Requires featureCompatibilityVersion set to 4.0. New in version 4.0.
    MONGODB-X509 | MongoDB TLS/SSL certificate authentication.
    GSSAPI (Kerberos) | External authentication using Kerberos. This mechanism is available only in MongoDB Enterprise.
    PLAIN (LDAP SASL) | External authentication using LDAP. You can also use PLAIN for authenticating in-database users. PLAIN transmits passwords in plain text. This mechanism is available only in MongoDB Enterprise.

    NOTE: You cannot specify both --authenticationMechanism and --uri.

--gssapiServiceName=<serviceName>
    New in version 2.6.

    Specify the name of the service using GSSAPI/Kerberos. Only required if the service does not use the default name of mongodb.

    This option is available only in MongoDB Enterprise.

--gssapiHostName=<hostname>
    New in version 2.6.

    Specify the hostname of a service using GSSAPI/Kerberos. Only required if the hostname of a machine does not match the hostname resolved by DNS.

    This option is available only in MongoDB Enterprise.

--db=<database>, -d=<database>
    Specifies the name of the database on which to run the mongoexport.

    NOTE: You cannot specify both --db and --uri.

--collection=<collection>, -c=<collection>
    Specifies the collection to export.

--fields=<field1[,field2]>, -f=<field1[,field2]>
    Specifies a field or fields to include in the export. Use a comma separated list of fields to specify multiple fields.

    If any of your field names include white space, use quotation marks to enclose the field list. For example, if you wished to export two fields, phone and user number, you would specify --fields "phone,user number".

    For csv output formats, mongoexport includes only the specified field(s), and the specified field(s) can be a field within a sub-document.

    For JSON output formats, mongoexport includes only the specified field(s) and the _id field, and if the specified field(s) is a field within a sub-document, the mongoexport includes the sub-document with all its fields, not just the specified field within the document.

    See: Export Data in CSV Format using --fields option for sample usage.

--fieldFile=<filename>
    An alternative to --fields. The --fieldFile option allows you to specify in a file the field or fields to include in the export and is only valid with the --type option with value csv. The file must have only one field per line, and the line(s) must end with the LF character (0x0A).

    mongoexport includes only the specified field(s). The specified field(s) can be a field within a sub-document.

    See Use a File to Specify the Fields to Export in CSV Format for sample usage.

--query=<JSON>, -q=<JSON>
    Provides a query as a JSON document (enclosed in quotes) to return matching documents in the export.

    You must enclose the query document in single quotes ('{ ... }') to ensure that it does not interact with your shell environment.

    Starting in MongoDB 4.2, the query must be in Extended JSON v2 format (either relaxed or canonical/strict mode), including enclosing the field names and operators in quotes:

    For example, given a collection named records in the database test with the following documents:

    { "_id" : ObjectId("51f0188846a64a1ed98fde7c"), "a" : 1, "date" : ISODate("1960-05-01T00:00:00Z") }
    { "_id" : ObjectId("520e61b0c6646578e3661b59"), "a" : 1, "b" : 2, "date" : ISODate("1970-05-01T00:00:00Z") }
    { "_id" : ObjectId("520e642bb7fa4ea22d6b1871"), "a" : 2, "b" : 3, "c" : 5, "date" : ISODate("2010-05-01T00:00:00Z") }
    { "_id" : ObjectId("520e6431b7fa4ea22d6b1872"), "a" : 3, "b" : 3, "c" : 6, "date" : ISODate("2015-05-02T00:00:00Z") }
    { "_id" : ObjectId("520e6445b7fa4ea22d6b1873"), "a" : 5, "b" : 6, "c" : 8, "date" : ISODate("2018-03-01T00:00:00Z") }
    { "_id" : ObjectId("5cd0de910dbce4346295ae28"), "a" : 15, "b" : 5, "date" : ISODate("2015-03-01T00:00:00Z") }

    The following mongoexport uses the -q option to export only the documents with the field a greater than or equal to ($gte) to 3 and the field date less than ISODate("2016-01-01T00:00:00Z") (using the extended JSON v2 format (relaxed mode) for dates { "$date": "YYYY-MM-DDTHH:mm:ss.mmm<offset>"}):

    mongoexport -d=test -c=records -q='{ "a": { "$gte": 3 }, "date": { "$lt": { "$date": "2016-01-01T00:00:00.000Z" } } }' --out=exportdir/myRecords.json

    The resulting file contains the following documents:

    {"_id":{"$oid":"520e6431b7fa4ea22d6b1872"},"a":3.0,"b":3.0,"c":6.0,"date":{"$date":"2015-05-02T00:00:00Z"}}
    {"_id":{"$oid":"5cd0de910dbce4346295ae28"},"a":15.0,"b":5.0,"date":{"$date":"2015-03-01T00:00:00Z"}}

    You can sort the results with the --sort option to mongoexport.

--type=<string>
    Default: json

    New in version 3.0.

    Specifies the file type to export. Specify csv for CSV format or json for JSON format.

    If you specify csv, then you must also use either the --fields or the --fieldFile option to declare the fields to export from the collection.

--out=<file>, -o=<file>
    Specifies a file to write the export to. If you do not specify a file name, the mongoexport writes data to standard output (e.g. stdout).

--jsonFormat=<canonical|relaxed>
    Default: relaxed

    Modifies the output to use either canonical or relaxed mode of the /reference/mongodb-extended-json format.

    For differences between canonical and relaxed modes, see /reference/mongodb-extended-json.

--jsonArray
    Modifies the output of mongoexport to write the entire contents of the export as a single JSON array. By default mongoexport writes data using one JSON document for every MongoDB document.

--pretty
    New in version 3.0.0.

    Outputs documents in a pretty-printed format JSON.

--noHeaderLine
    New in version 3.4.

    By default, mongoexport includes the exported field names as the first line in a CSV output. --noHeaderLine directs mongoexport to export the data without the list of field names. --noHeaderLine is only valid with the --type option with value csv.

    See Exclude Field Names from CSV Output for sample usage.

--slaveOk, -k
    Deprecated since version 3.2.

    Sets the replica-set-read-preference to nearest, allowing mongoexport to read data from secondary replica set members.

    --readPreference replaces --slaveOk in MongoDB 3.2. You cannot specify --slaveOk when --readPreference is specified.

    WARNING: Using a read preference other than primary with a connection to a mongos may produce inconsistencies, duplicates, or result in missed documents.

--readPreference=<string|document>
    Default: primary

    Specifies the read preference for mongoexport. The --readPreference option can take:

•   A string if specifying only the read preference mode:

    --readPreference=secondary

•   A quote-enclosed document to specify the mode, the optional read preference tag sets, and the optional maxStalenessSeconds:

    --readPreference='{mode: "secondary", tagSets: [ { "region": "east" } ], maxStalenessSeconds: 120}'

    If specifying the maxStalenessSeconds, the value must be greater than or equal to 90.

    New in version 4.2.

    mongoexport defaults to primary read preference.

    Starting in version 4.2, if the read preference is also included in the --uri connection string, the command-line --readPreference overrides the read preference specified in the URI string.

    WARNING: Using a read preference other than primary with a connection to a mongos may produce inconsistencies, duplicates, or result in missed documents.

--forceTableScan
    Forces mongoexport to scan the data store directly instead of traversing the _id field index. Use --forceTableScan to skip the index. Typically there are two cases where this behavior is preferable to the default:

1.  If you have key sizes over 800 bytes that would not be present in the _id index.

2.  Your database uses a custom _id field.

    When you run with --forceTableScan, mongoexport may return a document more than once if a write operation interleaves with the operation to cause the document to move.

    WARNING: Use --forceTableScan with extreme caution and consideration.

--skip=<number>
    Use --skip to control where mongoexport begins exporting documents. See skip() for information about the underlying operation.

--limit=<number>
    Specifies a maximum number of documents to include in the export. See limit() for information about the underlying operation.

--sort=<JSON>
    Specifies an ordering for exported results. If an index does not exist that can support the sort operation, the results must be less than 32 megabytes.

    Use --sort conjunction with --skip and --limit to limit number of exported documents.

    mongoexport -d=test -c=records --sort='{a: 1}' --limit=100 --out=export.0.json
    mongoexport -d=test -c=records --sort='{a: 1}' --limit=100 --skip=100 --out=export.1.json
    mongoexport -d=test -c=records --sort='{a: 1}' --limit=100 --skip=200 --out=export.2.json

    See sort() for information about the underlying operation.

EXAMPLES

  Export in CSV Format

Changed in version 3.0.0: mongoexport removed the --csv option. Use the --type=csv option to specify CSV format for the output.

  Export Data in CSV Format using --fields option

In the following example, mongoexport exports data from the collection contacts collection in the users database in CSV format to the file /opt/backups/contacts.csv.

The mongod instance that mongoexport connects to is running on the localhost port number 27017.

When you export in CSV format, you must specify the fields in the documents to export. The operation specifies the name and address fields to export.

mongoexport --db=users --collection=contacts --type=csv --fields=name,address --out=/opt/backups/contacts.csv

The output would then resemble:

name, address
Sophie Monroe, 123 Example Road
Charles Yu, 345 Sample Street

  Use a File to Specify the Fields to Export in CSV Format

For CSV exports only, you can also specify the fields in a file containing the line-separated list of fields to export. The file must have only one field per line.

For example, you can specify the name and address fields in a file fields.txt:

name
address

Then, using the --fieldFile option, specify the fields to export with the file:

mongoexport --db=users --collection=contacts --type=csv --fieldFile=fields.txt --out=/opt/backups/contacts.csv

  Exclude Field Names from CSV Output

New in version 3.4.

MongoDB 3.4 added the --noHeaderLine option for excluding the field names in a CSV export. The following example exports the name and address fields in the contacts collection in the users database and uses --noHeaderLine to suppress the output of the field names as the first line:

mongoexport --db=users --collection=contacts --type=csv --fields=name,address --noHeaderLine --out=/opt/backups/contacts.csv

The CSV output would then resemble:

Sophie Monroe, 123 Example Road
Charles Yu, 345 Sample Street

  Export in JSON Format

This example creates an export of the contacts collection from the MongoDB instance running on the localhost port number 27017. This writes the export to the contacts.json file in JSON format.

mongoexport --db=sales --collection=contacts --out=contacts.json

  Export from Remote Host Running with Authentication

The following example exports the contacts collection in the marketing database from a remote MongoDB instance that requires authentication.

Specify the:

•   --host

•   --port

•   --username

•   --authenticationDatabase

•   --collection

•   --db

•   --out

  Tip

Omit the --password option to have mongoexport prompt for the password:

mongoexport --host=mongodb1.example.net --port=27017 --username=someUser --authenticationDatabase=admin --collection=contacts --db=marketing --out=mdb1-examplenet.json

Alternatively, you use the --uri option to specify the host, port, username, authentication database, and db.

  Tip

Omit the password in the URI string to have mongoexport prompt for the password:

mongoexport --uri='mongodb://someUser@mongodb0.example.com:27017/marketing?authsource=admin' --collection=contacts --out=mdb1-examplenet.json

  Export Query Results

You can export only the results of a query by supplying a query filter with the --query option, and limit the results to a single database using the "--db" option.

For instance, this command returns all documents in the sales database's contacts collection that contain a field named dept equal to "ABC" and the field date greater than or equal to ISODate("2018-01-01") (using the canonical format for dates { "$date": "YYYY-MM-DDTHH:mm:ss.mmm<offset>"} )

mongoexport --db=sales --collection=contacts --query='{"dept": "ABC", date: { $gte: { "$date": "2018-01-01T00:00:00.000Z" } }}'

You must enclose the query document in single quotes ('{ ... }') to ensure that it does not interact with your shell environment.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2008-2019